#!/usr/bin/perl -w

#
# pipeline_basic.pl
# Copyright (C) 2007 by John Heidemann
# $Id: pipeline_basic.pl 567 2007-11-18 05:23:47Z johnh $
#
# This program is distributed under terms of the GNU general
# public license, version 2.  See the file COPYING
# in $dblibdir for details.
#

# next line is just to suppress the comment about threads::shared
use threads;

use Jdb::BoundedQueue;
use Jdb::Filter::dbcol;
use Jdb::Filter::dbroweval;

# do the equivalent of
#
#   cat DATA/grades.jdb | dbcol name test1 | dbroweval '_test1 += 5;'

my $pipe = new Jdb::BoundedQueue;
my $dbcol = new Jdb::Filter::dbcol('--output' => $pipe, qw(name test1));
my $dbrow = new Jdb::Filter::dbroweval('--input' => $pipe, '_test1 += 5;');

#
# first, just see if it works without threads
# (count on $pipe) to buffer the whole data, which it should.
#
$dbcol->setup_run_finish;
$dbrow->setup_run_finish;

exit 0;
